diff -ruN freeswan-1.5.orig/pluto/openssl.c freeswan-1.5/pluto/openssl.c
--- freeswan-1.5.orig/pluto/openssl.c	Wed Dec 31 19:00:00 1969
+++ freeswan-1.5/pluto/openssl.c	Thu Oct  5 07:05:59 2000
@@ -0,0 +1,1827 @@
+#ifdef OPENSSL
+#include <stdlib.h>
+#include <string.h>
+#include <ctype.h>
+#include <sys/stat.h>
+#include <unistd.h>
+#include <netinet/in.h>
+#include <netdb.h>
+#include <sys/socket.h>
+#include <netinet/in.h>
+#include <arpa/inet.h>
+
+#include <sys/types.h>
+#include <dirent.h>
+
+#include <freeswan.h>
+
+#include <openssl/pem.h>
+
+#include "constants.h"
+#include "defs.h"
+#include "id.h"
+#include "connections.h" /* needs id.h */
+#include "state.h"
+#include "kernel.h"
+#include "log.h"
+#include "packet.h"
+#include "spdb.h"
+#include "demux.h"
+#include "openssl.h"
+#include "xmap.h"
+
+
+struct _tok_node {
+  char *s;
+  struct _tok_node *next;
+};
+
+typedef struct _tok_node *tok_list;
+
+enum tok_state { TOK_NORMAL, TOK_QUOTE, TOK_BACKSLASH, TOK_BACKSLASH_Q };
+
+void tok_append(tok_list *t, const char *s);
+tok_list tokenize( const char *s, const char sep );
+void tok_free( tok_list t );
+X509_CRL *lookup_crl(STACK_OF(XMAP) *lu, X509_NAME *name);
+X509 *lookup_cert_by_subject(STACK_OF(XMAP) *lu, X509_NAME *name);
+void build_cert_chain( STACK_OF(X509) **ch, STACK_OF(XMAP) *lu, X509 *x );
+static int cert_compare(X509 *a, X509 *b);
+static STACK_OF(X509) *lookup_certs_by_ip(STACK_OF(XMAP) *lu,
+					  const char *id,
+					  const size_t len);
+static int ASN1_UTCTIME_cmp(ASN1_UTCTIME *a, ASN1_UTCTIME *b);
+static bool have_othercert( struct state *st, int type );
+static int cb( int ok, X509_STORE_CTX *ctx );
+
+void
+tok_append(tok_list *t, const char *s) {
+  tok_list p, pp;
+
+  if (!t) return;
+  if ((p = malloc(sizeof(struct _tok_node))) == NULL) return;
+  if ((p->s = strdup(s)) == NULL) { free(p); return; }
+  p->next = NULL;
+
+  if (*t == NULL) { *t = p; return; }; /* Empty list */
+  pp = *t;
+  while (pp->next != NULL) pp = pp->next;
+  pp->next = p;
+}
+
+tok_list
+tokenize( const char *s, const char sep )
+{
+  tok_list t = NULL;
+  int len, i, cnt, size;
+  char *buf;
+  enum tok_state st = TOK_NORMAL;
+
+  cnt = 0;
+  len = strlen(s);
+  size = 256; /* Initial size */
+  if ((buf = malloc(size)) == NULL) return t;
+  memset(buf, 0, size);
+  for(i=0; i<len; i++) {
+    /* resize buf if necessary */
+    if (cnt == size-1) {
+      size += 256;
+      if ((buf = realloc(buf, size)) == NULL) return t;
+    }
+    switch(st) {
+    case TOK_NORMAL:
+      if (s[i] == '\\')
+	st = TOK_BACKSLASH;
+      else if (s[i] == '\'')
+	st = TOK_QUOTE;
+      else if (s[i] == sep) {
+	/* Reached the end of a token */
+	tok_append(&t, buf);
+	memset(buf, 0, size);
+	cnt = 0;
+      } else {
+	buf[cnt] = s[i];
+	cnt++;
+	buf[cnt] = '\0';
+      }
+      break;
+    case TOK_QUOTE:
+      if (s[i] == '\\')
+	st = TOK_BACKSLASH_Q;
+      else if (s[i] == '\'') {
+	st = TOK_NORMAL;
+      } else {
+	buf[cnt] = s[i];
+	cnt++;
+	buf[cnt] = '\0';
+      }
+      break;
+    case TOK_BACKSLASH:
+      buf[cnt] = s[i];
+      cnt++;
+      buf[cnt] = '\0';
+      st = TOK_NORMAL;
+      break;
+    case TOK_BACKSLASH_Q:
+      buf[cnt] = s[i];
+      cnt++;
+      buf[cnt] = '\0';
+      st = TOK_QUOTE;
+      break;
+    }
+  }
+  tok_append(&t, buf);
+  memset(buf, 0, size);
+  cnt = 0;
+  free(buf);
+  return t;
+}
+
+void
+tok_free( tok_list t )
+{
+  tok_list p = t;
+
+  while (p) {
+    tok_list pp = p->next;
+
+    free(p->s);
+    free(p);
+    p = pp;
+  }
+}
+
+void
+log_err( void )
+{
+  unsigned long l;
+  char buf[200];
+  const char *file, *data;
+  int line, flags;
+  unsigned long es;
+  
+  es=CRYPTO_thread_id();
+  while ((l=ERR_get_error_line_data(&file,&line,&data,&flags)) != 0)
+    {
+      log("%lu:%s:%s:%d:%s\n",es,ERR_error_string(l,buf),
+	  file,line,(flags&ERR_TXT_STRING)?data:"");
+    }
+}
+
+void
+make_lookups( STACK_OF(XMAP) **lu, const char *spec )
+{
+#define MAXSPEC 10
+  const char *delim = ", ";
+  char *s, *p, *specs[MAXSPEC];
+  int i;
+  XMAP *xm;
+
+  for(i=0; i<MAXSPEC; i++) specs[i] = NULL;
+  s = clone_bytes(spec, strlen(spec)+1, "lookup specification");
+  p = strtok(s, delim);
+  i = 0;
+  while ((i < MAXSPEC) && (p)) {
+    char *sp = clone_bytes(p, strlen(p)+1, "lookup spec");
+    specs[i++] = sp;
+    p = strtok( NULL, delim );
+  }
+
+  if ((*lu = sk_XMAP_new_null()) != NULL) {
+    for(i=0; specs[i]; i++) {
+      DBG(DBG_PARSING,
+      DBG_log("Adding LU spec: %s", specs[i]);
+      );
+      if ((xm = XMAP_new(specs[i])) != NULL) sk_XMAP_push(*lu, xm);
+    }
+  }
+  
+  for(i=0; specs[i]; i++) pfree(specs[i]);
+  pfree(s);
+}
+
+/* Really need to make this routine far more tolerant */
+/* of other formats for certs & keys. For example, it */
+/* would be nice to be able to use PKCS8 private key forms */
+/* or a PKCS12 bag to hold both certificate and key */
+/* For the moment, though, we can handle certs in DER or */
+/* PEM format, and keys in PEM format only -- nd */
+void
+load_cert_and_key( const char *cert, const char *key,
+		   X509 **x, EVP_PKEY **k )
+{
+  BIO *b = NULL;
+  char keystr[32] = "PEM private key";
+
+  log("Loading certificates and key");
+  if ((! x) || (! k)) return;
+  *x = NULL;
+  *k = NULL;
+  if (cert[0] == '\0') return;
+  if (key[0] == '\0') return;
+
+  if ((b = BIO_new_file(cert, "r")) == NULL) {
+    log_err();
+    return;
+  }
+#if OPENSSL_VERSION_NUMBER > 0x00903000L
+  *x = PEM_read_bio_X509(b, NULL, NULL, NULL);
+#else
+  *x = PEM_read_bio_X509(b, NULL, NULL);
+#endif
+  if (*x == NULL) {
+    /* Try DER read */
+    BIO_ctrl(b, BIO_CTRL_RESET, 0, NULL);
+    if ((*x = d2i_X509_bio(b, NULL)) == NULL) {
+      log_err();
+      BIO_free(b);
+      return;
+    }
+  }
+  DBG(DBG_PARSING,
+  DBG_log("Read certificate from %s", cert);
+  );
+  BIO_free(b);
+  
+  if ((b = BIO_new_file(key, "r")) == NULL) {
+    log_err();
+    X509_free(*x);
+    *x = NULL;
+    return;
+  }
+  
+#if OPENSSL_VERSION_NUMBER > 0x00903000L
+  *k = PEM_read_bio_PrivateKey(b, NULL, NULL, NULL);
+#else
+  *k = PEM_read_bio_PrivateKey(b, NULL, NULL);
+#endif
+  if (!*k) {
+    RSA *r;
+    
+    /* Try DER reading of RSA Key */
+    BIO_ctrl(b, BIO_CTRL_RESET, 0, NULL);
+    r = d2i_RSAPrivateKey_bio(b, NULL);
+    if (r) {
+      if ((*k = EVP_PKEY_new()) != NULL) {
+	(*k)->type = EVP_PKEY_RSA;
+	(*k)->pkey.rsa = r;
+	strncpy(keystr, "DER RSA private key", sizeof(keystr)-1);
+      } else
+	RSA_free(r);
+    }
+  }
+  
+  if (!*k) {
+    DSA *d;
+    
+    /* Try DER reading of DSA/El Gamal Key */
+    BIO_ctrl(b, BIO_CTRL_RESET, 0, NULL);
+    d = d2i_DSAPrivateKey_bio(b, NULL);
+    if (d) {
+      if ((*k = EVP_PKEY_new()) != NULL) {
+	(*k)->type = EVP_PKEY_DSA;
+	(*k)->pkey.dsa = d;
+	strncpy(keystr, "DER DSA private key", sizeof(keystr)-1);
+      } else
+	DSA_free(d);
+    }
+  }
+  
+  if (!*k) {
+    PKCS8_PRIV_KEY_INFO *p8inf = NULL;
+    
+    BIO_ctrl(b, BIO_CTRL_RESET, 0, NULL);
+    /* try PKCS8 (unencrypted) keyform */
+    
+    BIO_ctrl(b, BIO_CTRL_RESET, 0, NULL);
+    p8inf = PEM_read_bio_PKCS8_PRIV_KEY_INFO(b, NULL, NULL, NULL);
+    if (!p8inf) {
+      /* Try reading PKCS8 in DER format */
+      BIO_ctrl(b, BIO_CTRL_RESET, 0, NULL);
+      p8inf = d2i_PKCS8_PRIV_KEY_INFO_bio(b, NULL);
+    } else 
+      strncpy(keystr, "PEM PKCS-8 private key", sizeof(keystr)-1);
+    if (!p8inf) {
+      log("Error in loading PKCS-8 private key");
+      log_err();
+      X509_free(*x);
+      *x = NULL;
+      BIO_free(b);
+      return;
+    } else
+      strncpy(keystr, "DER PKCS-8 private key", sizeof(keystr)-1);
+    if ((*k = EVP_PKCS82PKEY(p8inf)) == NULL) {
+      log("Error in converting PKCS-8 private key");
+      log_err();
+      X509_free(*x);
+      *x = NULL;
+      BIO_free(b);
+      return;
+    }
+  }
+  DBG(DBG_PARSING,
+  DBG_log("Read %s from %s", keystr, key);
+  );
+  BIO_free(b);
+}
+
+static int
+cert_compare(X509 *a, X509 *b)
+{
+  /* Check for equality of 2 X509 certificates */
+  /* certs are equal if their issuers, serial numbers */
+  /* subject names and public keys are the same */
+  /* We could probably do all of this by converting the */
+  /* certs to DER format and comparing the byte streams */
+  /* but that's likely to be inefficient -- nd */
+  int c;
+  EVP_PKEY *ka, *kb;
+
+  if ((c = X509_issuer_and_serial_cmp(a, b)) != 0)
+    return c;
+  if ((c = X509_NAME_cmp(X509_get_issuer_name(a),
+			 X509_get_issuer_name(b))) != 0)
+    return c;
+  ka = X509_get_pubkey(a);
+  kb = X509_get_pubkey(b);
+  if (ka->type != kb->type) return 1;
+  switch (ka->type) {
+  case EVP_PKEY_RSA:
+    {
+      /* RSA compare - if public exponent and modulus are equal, return 0 */
+      RSA *ra, *rb;
+
+      ra = ka->pkey.rsa;
+      rb = ka->pkey.rsa;
+
+      if (BN_cmp(ra->e, rb->e) != 0) return 1;
+      if (BN_cmp(ra->n, rb->n) != 0) return 1;
+    }
+    break;
+  case EVP_PKEY_DSA:
+    {
+      /* DSA compare, g, modulus and pubkey must be equal */
+      DSA *da, *db;
+
+      da = ka->pkey.dsa;
+      db = ka->pkey.dsa;
+
+      if (BN_cmp(da->g, db->g) != 0) return 1;
+      if (BN_cmp(da->p, db->p) != 0) return 1;
+      if (BN_cmp(da->pub_key, db->pub_key) != 0) return 1;
+    }
+    break;
+  default:
+    DBG(DBG_PARSING,
+    DBG_log("Unknown key type presented: %d", ka->type);
+    );
+    return 1;
+    break;
+  }
+  return 0;
+}
+
+static STACK_OF(X509) *
+lookup_certs_by_ip(STACK_OF(XMAP) *lu,
+		   const char *id,
+		   const size_t len)
+{
+  STACK_OF(X509) *osk = sk_X509_new_null();
+  int i;
+
+  for(i=0; i<sk_XMAP_num(lu); i++) {
+    XMAP *xm = sk_XMAP_value(lu, i);
+    u_char *cl = clone_bytes(id, len, "IPv4 address");
+    STACK_OF(X509_OBJECT) *op = NULL;
+
+	DBG(DBG_PARSING | DBG_CONTROL,
+    DBG_log("Searching map %d", i+1);
+    DBG_dump("IPv4:", cl, len);
+	);
+    if ((op = XMAP_lookup(xm, X509_LU_X509, "ip", cl)) != NULL) {
+      int j;
+
+      DBG(DBG_PARSING,
+      DBG_log("Search returns %d certificates", sk_X509_OBJECT_num(op));
+      );
+      for(j=0; j < sk_X509_OBJECT_num(op); j++) {
+	X509_OBJECT *o = sk_X509_OBJECT_value(op, j);
+	X509 *c = X509_dup(o->data.x509);
+	int k, found;
+
+	for(k=0, found=0; (!found) && (k < sk_X509_num(osk)); k++) {
+	  if (cert_compare(sk_X509_value(osk, k), c) == 0)
+	    found = 1;
+	}
+
+	if (!found) {
+	  if (sk_X509_num(osk) == 0) {
+	    sk_X509_push(osk, c);
+	  } else {
+	    ASN1_UTCTIME *new_notBefore = X509_get_notBefore(c);
+	    ASN1_UTCTIME *new_notAfter = X509_get_notAfter(c);
+	    
+	    for(k=0; k<sk_X509_num(osk); k++) {
+	      X509 *tx = sk_X509_value(osk, k); /* certificate already in stack */
+	      ASN1_UTCTIME *notBefore = X509_get_notBefore(tx);
+	      ASN1_UTCTIME *notAfter = X509_get_notAfter(tx);
+	      int c1 = ASN1_UTCTIME_cmp(new_notBefore, notBefore);
+	      int c2 = ASN1_UTCTIME_cmp(new_notAfter, notAfter);
+	      
+	      if (c1 == 0) {
+		/* certs start at same time */
+		if (c2 > 0) break; /* insert here if c expiry is later than tx */
+	      } else
+	      if (c1 > 0) break; /* insert here is c start date is later than tx */
+	      /* else move on to the next certificate in the current output stack */
+	    }
+	    sk_X509_insert(osk, c, k); /* Insert into the output stack */
+	  }
+	}
+      }
+      sk_X509_OBJECT_pop_free(op, X509_OBJECT_free);
+      pfree(cl);
+    }
+  }
+  if (osk) DBG(DBG_PARSING,
+	DBG_log("Returning %d certs in list", sk_X509_num(osk)));
+  return osk;
+} 
+
+/* peer_cert_list takes a supplied list of XMAPs */
+/* and adds all of the X509 certificates whose */
+/* public key matches 'type' into a safe stack certificates */
+/* If the parameter 'cert' is non-NULL, only the certificate */
+/* which matches it will be added to the list */
+STACK_OF(X509) *
+peer_cert_list( STACK_OF(XMAP) *lu, int type, X509 *cert,
+		struct payload_digest *const id_pld,
+		bool strict )
+{
+  STACK_OF(X509) *sk = NULL, *osk = NULL;
+  pb_stream *const id_pbs = &id_pld->pbs;
+  struct isakmp_id *const id = &id_pld->payload.id;
+  int i, found;
+
+  switch(id->isaid_idtype) {
+  case ID_IPV4_ADDR:
+    if (pbs_left(id_pbs) != sizeof(struct in_addr)) {
+      DBG(DBG_PARSING,
+      DBG_log("ID size is not equal to that of an IPv4 address");
+      );
+      return NULL;
+    }
+    if ((sk = lookup_certs_by_ip(lu,
+				id_pbs->cur,
+				sizeof(struct in_addr))) == NULL) {
+      DBG(DBG_PARSING,
+      DBG_log("No certs for this IP address");
+      );
+      return NULL;
+    }
+    break;
+  default:
+    DBG(DBG_PARSING,
+    DBG_log("No means to check certificates for ID type = %s",
+	    enum_show(&ident_names, id->isaid_idtype));
+    );
+    return NULL;
+  }
+
+  /* Now filter out any certificates not of type 'type' */
+  if ((osk = sk_X509_new_null()) != NULL) {
+    for(i=0; i<sk_X509_num(sk); i++) {
+      X509 *x = sk_X509_value(sk, i);
+      EVP_PKEY *pk = X509_get_pubkey(x);
+
+      if (pk->type == type) {
+	sk_X509_push(osk, X509_dup(x));
+      } else {
+    DBG(DBG_PARSING,
+	DBG_log("Rejecting certificate: wrong type: %d", pk->type);
+    );
+      }
+    }
+    sk_X509_pop_free(sk, X509_free);
+    sk = osk; /* Make sk the new filtered list */
+  } else {
+    DBG(DBG_PARSING,
+    DBG_log("Error in allocating new sk_X509");
+    );
+    sk_X509_pop_free(sk, X509_free);
+    sk = NULL;
+  }
+
+  if ((sk) && (cert)) {
+    /* If a certificate was presupplied, we want to check */
+    /* whether it is in the list of acceptable certificates */
+    /* for this connection. If no certificate is presupplied */
+    /* then it is assumed that one of the certificates in */
+    /* the list will correctly decrypt the signature/nonces */
+
+    for(i=0, found=0; ((!found) && (i < sk_X509_num(sk))); i++)
+      if (cert_compare(sk_X509_value(sk, i), cert) == 0) found = 1;
+
+    if (found) {
+      DBG(DBG_PARSING,
+      DBG_log("Certificate supplied is in list");
+      );
+    } else {
+      DBG(DBG_PARSING,
+      DBG_log("Certificate supplied is NOT in list");
+      );
+
+      /* If strict is not set, this certificate will be allowed */
+      /* to pass, even though the host cannot recognise it as */
+      /* in the list of known certificates for this ID. Otherwise */
+      /* we erase the list and return NULL -- an error condition */
+      if (strict) {
+	sk_X509_pop_free(sk, X509_free);
+	sk = NULL;
+      }
+    }
+  }
+
+  return sk;
+}
+
+bool
+have_rsa_key( struct state *st )
+{
+  struct connection *c = st->st_connection;
+
+  if (c->key == NULL) { 
+	DBG(DBG_PARSING,
+	DBG_log("No key present");
+	);
+	return FALSE; 
+  }
+  if ( ((EVP_PKEY *)(c->key))->type != EVP_PKEY_RSA ) { return FALSE; }
+  return TRUE;
+}
+
+bool
+have_dss_key( struct state *st )
+{
+  struct connection *c = st->st_connection;
+
+  if (c->key == NULL) { 
+	DBG(DBG_PARSING,
+	DBG_log("No key present"); 
+	);
+	return FALSE; 
+  }
+  if ( ((EVP_PKEY *)(c->key))->type != EVP_PKEY_DSA ) { return FALSE; }
+  return TRUE;
+}
+
+static bool
+have_othercert( struct state *st, int type )
+{
+  struct connection *c = st->st_connection;
+  struct end *that = &st->st_connection->that;
+  STACK_OF(X509) *op = NULL;
+  X509 *x;
+  int i;
+  bool found;
+
+  /* First check to see if we've already done */
+  /* this lookup and stored the certificate in */
+  /* c->other[] */
+
+  for(i=0; i<MAX_OTHER; i++)
+    if ((c->other[i].type == type) &&
+	(c->other[i].cert != NULL)) {
+      DBG(DBG_PARSING,
+      DBG_log("Already stored a type %d cert", type);
+      );
+      return TRUE;
+    }
+
+  op = lookup_certs_by_ip((STACK_OF(XMAP) *)c->lu,
+			  (const char *)&that->host_addr,
+			  sizeof(that->host_addr));
+  if (!op) {
+	DBG(DBG_PARSING,
+    DBG_log("IP lookup returns NULL");
+	);
+  } else {
+    int i;
+
+    for(i=0, found = FALSE; ((!found) && (i < sk_X509_num(op))); i++) {
+      x = sk_X509_value(op, i);
+      if (X509_get_pubkey(x)->type == type) {
+	found = TRUE;
+	for(i=0; i<MAX_OTHER; i++) {
+ 	  if (c->other[i].cert == NULL) {
+		DBG(DBG_PARSING,
+	    DBG_log("Storing type %d cert at position %d", type, i);
+		);
+	    c->other[i].type = type;
+	    c->other[i].cert = (void *)X509_dup(x);
+	    break;
+	  }
+	}
+      }
+    }
+
+    if (found) {
+      DBG(DBG_PARSING,
+      DBG_log("Found type %d cert at position %d:",
+	      type, i+1);
+      );
+    } else {
+      DBG(DBG_PARSING,
+      DBG_log("No appropriate cert found");
+      );
+    }
+    sk_X509_pop_free(op, X509_free);
+  }
+  return (found);
+}
+
+bool
+have_rsa_keypair( struct state *st )
+{
+  bool r = have_othercert(st, EVP_PKEY_RSA);
+
+  if (r) r = have_rsa_key(st);
+
+  DBG(DBG_PARSING,
+  DBG_log("Have RSA other cert = %s", r  ? "TRUE" : "FALSE");
+  );
+  return r;
+}
+
+bool
+have_elgamal_keypair( struct state *st )
+{
+  bool r = have_othercert(st, EVP_PKEY_DSA); 
+  if (r) r = have_dss_key(st);
+  DBG(DBG_PARSING,
+  DBG_log("Have El Gamal other cert = %s", r  ? "TRUE" : "FALSE");
+  );
+  return r;
+}
+
+static int
+cb( int ok, X509_STORE_CTX *ctx )
+{
+  char buf[200];
+  
+  if (!ok) {
+    if (ctx->error == X509_V_ERR_DEPTH_ZERO_SELF_SIGNED_CERT) {
+      /* Check to see if it is a CA certificate, ie with */
+      /* basicConstraints, and perhaps other checks */
+      /* For the moment, we just let it slide */
+      ok = 1;
+    } else {
+      X509_NAME_oneline(X509_get_subject_name(ctx->current_cert), buf, sizeof(buf));
+      
+      DBG(DBG_PARSING,
+      DBG_log("Error for certificate: %s", buf);
+      DBG_log("Error %d: Depth %d: %s",
+              ctx->error,
+              ctx->error_depth,
+              X509_verify_cert_error_string(ctx->error));
+      );
+    }
+  }
+  return (ok);
+}
+
+static int
+ASN1_UTCTIME_cmp(ASN1_UTCTIME *a, ASN1_UTCTIME *b)
+{
+  char buff1[14],buff2[14],*p;
+  int i,j;
+ 
+  /* Degenerate cases */
+  if (!a && !b) return 0;
+  if (a && !b) return 1;
+  if (!a && b) return -1;
+ 
+  memset(buff1, 0, sizeof(buff1));
+  memset(buff2, 0, sizeof(buff2));
+ 
+  p=buff1;
+  i=a->length;
+  if ((i < 11) || (i > 17)) return(0);
+  memcpy(p,a->data,12);
+ 
+  p=buff2;
+  j=b->length;
+  if ((j < 11) || (j > 17)) return(0);
+  memcpy(p,b->data,12);
+ 
+  /* Correct for Y2K */
+  i=(buff1[0]-'0')*10+(buff1[1]-'0');
+  if (i < 50) i+=100; /* cf. RFC 2459 */
+  j=(buff2[0]-'0')*10+(buff2[1]-'0');
+  if (j < 50) j+=100;
+ 
+  if (i < j) return (-1);
+  if (i > j) return (1);
+ 
+  i=strcmp(buff1,buff2);
+ 
+  if (i == 0)
+    return 0;
+  else if (i < 0)
+    return(-1);
+  else
+    return(1);
+}
+
+X509_CRL *
+lookup_crl(STACK_OF(XMAP) *lu, X509_NAME *name)
+{
+  X509_CRL *x = NULL;
+  STACK_OF(X509_CRL) *osk = sk_X509_CRL_new_null();
+  int i, j, k, found;
+
+  for(i=0; i<sk_XMAP_num(lu); i++) {
+    XMAP *xm = sk_XMAP_value(lu, i);
+    STACK_OF(X509_OBJECT) *xo = NULL;
+
+    if (xm) {
+      XMAP_dump(xm);
+      if ((xo = XMAP_lookup(xm, X509_LU_CRL, "issuer", name)) != NULL) {
+	for(j=0; j<sk_X509_OBJECT_num(xo); j++) {
+	  X509_OBJECT *o = sk_X509_OBJECT_value(xo, j);
+	  X509_CRL *xx = X509_CRL_dup(o->data.crl);
+	  
+	  for(k=0, found = 0; (!found) && (k<sk_X509_CRL_num(osk)); k++) {
+	    X509_CRL *tx = sk_X509_CRL_value(osk, k);
+	    
+	    if ((X509_NAME_cmp(X509_CRL_get_issuer(xx),
+			       X509_CRL_get_issuer(tx))==0) &&
+		(ASN1_UTCTIME_cmp(X509_CRL_get_lastUpdate(xx),
+				  X509_CRL_get_lastUpdate(tx)) == 0) &&
+		(ASN1_UTCTIME_cmp(X509_CRL_get_nextUpdate(xx),
+				  X509_CRL_get_nextUpdate(tx)) == 0))
+	      found = 1;
+	  }
+	  
+	  if (!found) {
+	    if (sk_X509_CRL_num(osk) == 0)
+	      sk_X509_CRL_push(osk, xx);
+	    else {
+	      /* insert the certificate into the stack in date order */
+	      for(k=0; k<sk_X509_CRL_num(osk); k++) {
+		X509_CRL *tx = sk_X509_CRL_value(osk, k); /* certificate already in stack */
+		
+		if (ASN1_UTCTIME_cmp(X509_CRL_get_lastUpdate(xx),
+				     X509_CRL_get_lastUpdate(tx)) > 0)
+		  break; /* insert here if last Update is newer than current crl */
+	      }
+	      
+	      sk_X509_CRL_insert(osk, xx, k); /* Insert into the output stack */            }
+	  } else
+	    X509_CRL_free(xx);
+	}
+	sk_X509_OBJECT_pop_free(xo, X509_OBJECT_free); /* drop search return values */
+      }
+    }
+  }
+
+  if (sk_X509_CRL_num(osk) > 0)
+    x = X509_CRL_dup(sk_X509_CRL_value(osk, 0)); /* use first certificate in stack */
+  sk_X509_CRL_pop_free(osk, X509_CRL_free); /* get rid of output stack */
+  return x; 
+}
+
+static STACK_OF(XMAP) *lookups = NULL;
+static bool verify_strict;
+/* only way I can think to get the verify function (which is) */
+/* used as a callback to access the 'strict verification' flag */
+/* The problem is that there isn't any space in the parameters */
+/* to the verify_func in which to add this flag. Pity, because */
+/* a static global controlling verification policy is a fairly */
+/* stinky idea -- nd */
+
+/* The following code is simply the code from x509_vfy.c */
+/* with CRL checking added, and basicConstraints checking */
+static int
+verify_func(X509_STORE_CTX *ctx)
+{
+  int i,ok=0,n;
+  X509 *xs,*xi;
+  EVP_PKEY *pkey=NULL;
+  int (*cb)();
+  X509_CRL *crl;
+  
+  cb=ctx->ctx->verify_cb;
+  
+  n=sk_X509_num(ctx->chain);
+  DBG(DBG_PARSING,
+  DBG_log("%d certs in chain", n);
+  );
+  ctx->error_depth=n-1;
+  n--;
+  xi=sk_X509_value(ctx->chain,n);
+  DBG(DBG_PARSING,
+  DBG_log("xi = %08X", (u_int32_t)xi);
+  );
+  if (X509_NAME_cmp(X509_get_subject_name(xi),
+		    X509_get_issuer_name(xi)) == 0)
+    xs=xi;
+  else {
+    if (n <= 0) {
+      ctx->error=X509_V_ERR_UNABLE_TO_VERIFY_LEAF_SIGNATURE;
+      ctx->current_cert=xi;
+      ok=cb(0,ctx);
+      goto end;
+    } else {
+      n--;
+      ctx->error_depth=n;
+      xs=sk_X509_value(ctx->chain,n);
+    }
+  }
+  
+  while (n >= 0) {
+    ctx->error_depth=n;
+    if (!xs->valid) {
+      if ((pkey=X509_get_pubkey(xi)) == NULL)
+	{
+	  ctx->error=X509_V_ERR_UNABLE_TO_DECODE_ISSUER_PUBLIC_KEY;
+	  ctx->current_cert=xi;
+	  ok=(*cb)(0,ctx);
+	  if (!ok) goto end;
+	}
+      if (X509_verify(xs,pkey) <= 0) {
+	EVP_PKEY_free(pkey);
+	ctx->error=X509_V_ERR_CERT_SIGNATURE_FAILURE;
+	ctx->current_cert=xs;
+	ok=(*cb)(0,ctx);
+	if (!ok) goto end;
+      }
+      EVP_PKEY_free(pkey);
+      pkey=NULL;
+
+      i=X509_cmp_current_time(X509_get_notBefore(xs));
+      if (i == 0) {
+	ctx->error=X509_V_ERR_ERROR_IN_CERT_NOT_BEFORE_FIELD;
+	ctx->current_cert=xs;
+	ok=(*cb)(0,ctx);
+	if (!ok) goto end;
+      }
+      if (i > 0) {
+	ctx->error=X509_V_ERR_CERT_NOT_YET_VALID;
+	ctx->current_cert=xs;
+	ok=(*cb)(0,ctx);
+	if (!ok) goto end;
+      }
+      xs->valid=1;
+    }
+
+    i=X509_cmp_current_time(X509_get_notAfter(xs));
+    if (i == 0) {
+      ctx->error=X509_V_ERR_ERROR_IN_CERT_NOT_AFTER_FIELD;
+      ctx->current_cert=xs;
+      ok=(*cb)(0,ctx);
+      if (!ok) goto end;
+    }
+    
+    if (i < 0) {
+      ctx->error=X509_V_ERR_CERT_HAS_EXPIRED;
+      ctx->current_cert=xs;
+      ok=(*cb)(0,ctx);
+      if (!ok) goto end;
+    }
+
+    if (n == sk_X509_num(ctx->chain)-1) {
+      /* This is the root certificate */
+      int loc = X509_get_ext_by_NID(xs, NID_basic_constraints, -1);
+      if (loc >= 0) {
+	X509_EXTENSION *ext;
+	BASIC_CONSTRAINTS *p = NULL;
+	
+	ext = X509_get_ext(xs, loc);
+	if (ext) {
+	  p = X509V3_EXT_d2i(ext);
+	  if (! p->ca) {
+	    BASIC_CONSTRAINTS_free(p);
+	    ctx->error=X509_V_ERR_SELF_SIGNED_CERT_IN_CHAIN;
+	    ctx->current_cert=xs;
+	    ok=(*cb)(0,ctx);
+	    if (!ok) goto end;
+	  } else {
+        DBG(DBG_PARSING,
+	    DBG_log("Root certificate has CA = True");
+        );
+	    BASIC_CONSTRAINTS_free(p);
+	  }
+	} else {
+	  /* The cert has a basicConstraints extension, but */
+	  /* we couldn't get it */
+	  ctx->error=X509_V_ERR_APPLICATION_VERIFICATION;
+	  ctx->current_cert=xs;
+	  ok=(*cb)(0,ctx);
+	  if (!ok) goto end;
+	}
+      } else {
+#ifndef DONT_BE_FASCIST
+	ctx->error=X509_V_ERR_SELF_SIGNED_CERT_IN_CHAIN;
+	ctx->current_cert=xs;
+	ok=(*cb)(0,ctx);
+	if (!ok) goto end;
+#endif
+      }
+    }
+
+    /* CRL CHECK */
+    if ((crl = lookup_crl(lookups, X509_get_issuer_name(xs))) != NULL) {
+      EVP_PKEY *pkey = X509_get_pubkey(xi);
+      STACK_OF(X509_REVOKED) *rev;
+      int nrev;
+      
+      DBG(DBG_PARSING,
+      DBG_log("Checking CRL for issuer");
+      );
+      
+      if (pkey == NULL) {
+	ctx->error=X509_V_ERR_UNABLE_TO_DECODE_ISSUER_PUBLIC_KEY;
+	X509_CRL_free(crl);
+	ctx->current_cert=xs;
+	ok=(*cb)(0,ctx);
+	if (!ok) goto end;
+      }
+      
+      if (X509_CRL_verify(crl, pkey) <= 0) {
+	ctx->error=X509_V_ERR_CRL_SIGNATURE_FAILURE;
+	X509_CRL_free(crl);
+	ctx->current_cert=xs;
+	ok=(*cb)(0,ctx);
+	if (!ok) goto end;
+      }
+      
+      i = X509_cmp_current_time(X509_CRL_get_lastUpdate(crl));
+      if (i == 0) {
+	ctx->error=X509_V_ERR_ERROR_IN_CRL_LAST_UPDATE_FIELD;
+	X509_CRL_free(crl);
+	ctx->current_cert=xs;
+	ok=(*cb)(0,ctx);
+	if (!ok) goto end;
+      }
+      if (i > 0) {
+	ctx->error=X509_V_ERR_CRL_NOT_YET_VALID;
+	X509_CRL_free(crl);
+	ctx->current_cert=xs;
+	ok=(*cb)(0,ctx);
+	if (!ok) goto end;
+      }
+      
+      i = X509_cmp_current_time(X509_CRL_get_nextUpdate(crl));
+      if (i == 0) {
+	ctx->error=X509_V_ERR_ERROR_IN_CRL_NEXT_UPDATE_FIELD;
+	X509_CRL_free(crl);
+	ctx->current_cert=xs;
+	ok=(*cb)(0,ctx);
+	if (!ok) goto end;
+      }
+      if (i < 0) {
+	ctx->error=X509_V_ERR_CRL_HAS_EXPIRED;
+	X509_CRL_free(crl);
+	ctx->current_cert=xs;
+	ok=(*cb)(0,ctx);
+	if (!ok) goto end;
+      }
+      
+      rev = X509_CRL_get_REVOKED(crl);
+      nrev = sk_X509_REVOKED_num(rev);
+      DBG(DBG_PARSING,
+      DBG_log("%d certificates revoked in CRL", nrev);
+      );
+      for(i=0; i<nrev; i++) {
+	X509_REVOKED *rv = sk_X509_REVOKED_value(rev, i);
+	
+	if (ASN1_INTEGER_cmp(X509_get_serialNumber(xs), rv->serialNumber) == 0) {
+	  /* It's this certificate that's been revoked */
+	  int c = X509_cmp_current_time(rv->revocationDate);
+	  if (c < 0) {
+	    ctx->error=X509_V_ERR_CERT_REVOKED;
+	    X509_CRL_free(crl);
+	    ctx->current_cert=xs;
+	    ok=(*cb)(0,ctx);
+	    if (!ok) goto end;
+	  }
+      DBG(DBG_PARSING,
+	  DBG_log("Serial Number matches");
+      );
+	}
+      }
+
+      X509_CRL_free(crl);
+    } else {
+      char buf[200];
+      
+      X509_NAME_oneline(X509_get_issuer_name(xs), buf, sizeof(buf));
+      DBG(DBG_PARSING,
+      DBG_log("Cant locate a CRL for issuer %s", buf);
+      );
+      /* If we're being paranoid here, we really should fail */
+      /* the verification. An attacker capable of mounting */
+      /* a denial of service attack could cause us fail to */
+      /* load the CRL, and use a revoked, but otherwise valid */
+      /* certificate in the  exchange to set up a valid SA */
+      /* In this case, we let it go, but an idea might be */
+      /* to have an ipsec.conf specified policy on how mandatory */
+      /* CRLs are in the verification sequence -- nd */
+      if (verify_strict) {
+	ctx->error=X509_V_ERR_UNABLE_TO_GET_CRL;
+	ctx->current_cert=xs;
+	ok=(*cb)(0,ctx);
+	if (!ok) goto end;
+      }
+    }
+
+    /* The last error (if any) is still in the error value */
+    ctx->current_cert=xs;
+    ok=(*cb)(1,ctx);
+    if (!ok) goto end;
+
+    n--;
+    if (n >= 0) {
+      xi=xs;
+      xs=sk_X509_value(ctx->chain,n);
+    }
+  }
+  ok=1;
+ end:
+  return(ok);
+}
+
+X509 *
+lookup_cert_by_subject(STACK_OF(XMAP) *lu, X509_NAME *xn)
+{
+  X509 *x = NULL; /* return value */
+  STACK_OF(X509) *osk = sk_X509_new_null(); /* output stack - concatenation of certificates */
+  int i, j, k, found;
+  
+  DBG(DBG_PARSING,
+  DBG_log("Looking up certificate by subject");
+  );
+  for(i=0; i<sk_XMAP_num(lu); i++) {
+    XMAP *xm = sk_XMAP_value(lu, i); /* individual searchable directory */
+    STACK_OF(X509_OBJECT) *xo = NULL; /* list of objects from individual searches */
+ 
+    if (xm) {
+      DBG(DBG_PARSING,
+      DBG_log("Searching map %d", i+1);
+      );
+      if ((xo = XMAP_lookup( xm, X509_LU_X509, "subject", xn)) != NULL) {
+        DBG(DBG_PARSING,
+        DBG_log("Got %d certificates", sk_X509_OBJECT_num(xo));
+        );
+        for(j=0; j<sk_X509_OBJECT_num(xo); j++) {
+          X509_OBJECT *o = sk_X509_OBJECT_value(xo, j);
+          X509 *xx = X509_dup(o->data.x509);
+ 
+          for(k=0, found = 0; (!found) && (k<sk_X509_num(osk)); k++) {
+            X509 *tx = sk_X509_value(osk, k);
+ 
+            if (X509_issuer_and_serial_cmp(xx, tx) == 0) found = 1;
+          }
+ 
+          DBG(DBG_PARSING,
+          DBG_log("Found = %d", found);
+          );
+          if (!found) {
+            if (sk_X509_num(osk) == 0) {
+              sk_X509_push(osk, xx);
+              DBG(DBG_PARSING,
+              DBG_log("Initialised cert stack");
+              );
+            } else {
+              /* insert the certificate into the stack in date order */
+              ASN1_UTCTIME *new_notBefore = X509_get_notBefore(xx);
+              ASN1_UTCTIME *new_notAfter = X509_get_notAfter(xx);
+ 
+              for(k=0; k<sk_X509_num(osk); k++) {
+                X509 *tx = sk_X509_value(osk, k); /* certificate already in stack */
+                ASN1_UTCTIME *notBefore = X509_get_notBefore(tx);
+                ASN1_UTCTIME *notAfter = X509_get_notAfter(tx);
+                int c1 = ASN1_UTCTIME_cmp(new_notBefore, notBefore);
+                int c2 = ASN1_UTCTIME_cmp(new_notAfter, notAfter);
+ 
+                if (c1 == 0) {
+                  /* certs start at same time */
+                  if (c2 > 0) break; /* insert here if xx expiry is later than tx */
+                } else
+                  if (c1 > 0) break; /* insert here is xx start date is later than tx */
+                /* else move on to the next certificate in the current output stack */
+              }
+              sk_X509_insert(osk, xx, k); /* Insert into the output stack */
+            }
+          } else
+            X509_free(xx);
+        }
+        sk_X509_OBJECT_pop_free(xo, X509_OBJECT_free);
+      }
+    }
+  }
+  DBG(DBG_PARSING,
+  DBG_log("Finished lookups");
+  );
+ 
+  if (sk_X509_num(osk) > 0)
+    x = X509_dup(sk_X509_value(osk, 0));
+  sk_X509_pop_free(osk, X509_free); /* get rid of output stack */
+  return x; 
+}
+
+void
+build_cert_chain( STACK_OF(X509) **ch, STACK_OF(XMAP) *lu, X509 *x )
+{
+  int done = 0;
+  X509 *xx;
+
+  if (!ch) return;
+  if ((*ch = sk_X509_new_null()) == NULL) return;
+  xx = x;
+  sk_X509_push(*ch, X509_dup(xx));
+  while (!done) {
+    X509 *xi;
+
+    DBG(DBG_PARSING,
+    DBG_log("Looking up certificate issuer");
+    );
+    if ((xi = lookup_cert_by_subject(lu, X509_get_issuer_name(xx))) != NULL) {
+      DBG(DBG_PARSING,
+      DBG_log("Pushing certificate onto stack");
+      );
+      sk_X509_push(*ch, xi);
+      DBG(DBG_PARSING,
+      DBG_log("Comparing subject and issuer");
+      );
+      if (X509_NAME_cmp(X509_get_subject_name(xi),
+			X509_get_issuer_name(xi)) == 0) {
+	done = 1;
+      } else {
+	xx = xi;
+      }
+      DBG(DBG_PARSING,
+      DBG_log("Done = %d", done);
+      );
+    } else 
+      done = 1; /* Cant find certificate */
+  }
+}
+
+bool
+verify_certificate( X509 *x, STACK_OF(XMAP) *lu,
+		    const char *path, bool strict )
+{
+  X509_STORE *ctx = NULL;
+  X509_STORE_CTX csc;
+  int ver;
+
+
+  if ((ctx = X509_STORE_new()) == NULL) {
+    DBG(DBG_PARSING,
+    DBG_log("Cant allocate file lookup");
+    );
+    log_err();
+    return 0;
+  }
+
+  X509_STORE_set_verify_cb_func(ctx, cb);
+
+  ERR_clear_error();
+  verify_strict = strict;
+  lookups = lu;
+  X509_STORE_CTX_init(&csc, ctx, x, NULL);
+  build_cert_chain(&(csc.chain), lu, x);
+  ver = verify_func(&csc);
+  X509_STORE_CTX_cleanup(&csc);
+
+  if (ctx) X509_STORE_free(ctx);
+
+  if (ver) {
+    DBG(DBG_PARSING,
+    DBG_log("Certificate verification succeeded");
+    );
+  } else {
+    DBG(DBG_PARSING,
+    DBG_log("Verification failed");
+    );
+    log_err();
+  }
+
+  return ver;
+}
+
+struct cert_options {
+  const char *opt;
+  u_int32_t optflag;
+};
+
+static struct cert_options certopts[] = {
+  { "send", CERT_OPTION_SEND },
+  { "pkcs7", CERT_OPTION_PKCS7 },
+  { "pk", CERT_OPTION_PK },
+  { "rev", CERT_OPTION_REV },
+  { "strict", CERT_OPTION_STRICT },
+  { "dss-sha", CERT_OPTION_DSS_SHA },
+  { "dss-alt", CERT_OPTION_DSS_ALT },
+  { NULL, 0 }
+};
+
+u_int32_t
+parse_options( const char *s )
+{
+  tok_list tl, p;
+  u_int32_t i, ret = 0, b4;
+
+  tl = tokenize(s, ',');
+  for(p=tl; p; p=p->next) {
+    int found = 0;
+    char *st = p->s;
+
+    while (isspace(*st)) st++; /* skip whitespace */
+    for(i=0; (!found) && (certopts[i].opt != NULL); i++) {
+      if ((st[0] == '!') &&
+	  (strncasecmp(&(st[1]), certopts[i].opt,
+		       strlen(certopts[i].opt)) == 0)) {
+	found = 1;
+	b4 = ret;
+	ret &= ~certopts[i].optflag;
+    DBG(DBG_PARSING,
+	DBG_log("Cert option: Clearing option %s: %08x -> %08x", certopts[i].opt, b4, ret);
+    );
+      } else if (strncasecmp(st, certopts[i].opt,
+			     strlen(certopts[i].opt)) == 0) {
+	found = 1;
+	b4 = ret;
+	ret |= certopts[i].optflag;
+    DBG(DBG_PARSING,
+	DBG_log("Cert option: Setting option %s: %08x -> %08x", certopts[i].opt, b4, ret);
+    );
+      }
+    }
+  }
+  tok_free(tl);
+  return ret;
+}
+int
+DSA_sign_raw(unsigned char *dgst,int dlen,
+	     unsigned char *sig, unsigned int *siglen, DSA *dsa)
+{
+  DSA_SIG *s;
+  int offset;
+
+  DBG(DBG_PARSING,
+  DBG_log("DSA_sign_raw called");
+  );
+  s= DSA_do_sign(dgst, dlen, dsa);
+  if (s == NULL) {
+    *siglen=0;
+    return 0;
+  }
+  memset(sig, 0, SHA1_DIGEST_SIZE * 2);
+  offset = SHA1_DIGEST_SIZE - BN_num_bytes(s->r);
+  BN_bn2bin(s->r, &(sig[offset]));
+  offset = SHA1_DIGEST_SIZE - BN_num_bytes(s->s);
+  BN_bn2bin(s->s, &(sig[SHA1_DIGEST_SIZE + offset]));
+  *siglen = SHA1_DIGEST_SIZE * 2;
+  DSA_SIG_free(s);
+  return 1;
+}
+
+int DSA_verify_raw(const unsigned char *dgst,int dgst_len,
+		   unsigned char *sigbuf, int siglen, DSA *dsa)
+{
+  DSA_SIG *s;
+  int ret = -1;
+
+  DBG(DBG_PARSING,
+  DBG_log("DSA_verify_raw called");
+  );
+  if (siglen != (2 * SHA1_DIGEST_SIZE)) return ret;
+  s = DSA_SIG_new();
+  if (s == NULL) return ret;
+  s->r = BN_bin2bn(sigbuf, SHA1_DIGEST_SIZE,
+		   s->r);
+  s->s = BN_bin2bn(&(sigbuf[SHA1_DIGEST_SIZE]),
+		   SHA1_DIGEST_SIZE,
+		   s->s);
+  ret=DSA_do_verify(dgst, dgst_len,s,dsa);
+  DSA_SIG_free(s);
+  return ret;
+}
+
+/*
+ * The following code implements ElGamal encryption using DSA keys
+ * in a (hopefully) OpenSSL compatible fashion. It really belongs in 
+ * OpenSSL itself, when the code approaches being both tested and
+ * more efficient. In order to make things a bit faster, the modular
+ * operations use montogomery representation.
+ *
+ * NB - this implementation is pretty naive, and contains just the
+ * simplest implementation of ElGamal as per HAC, Ch8, Section 8.4,
+ * pp 294-295.
+ */
+
+static ERR_STRING_DATA ElGamal_str_functs[] =
+{
+  {ERR_PACK(0,ELGAMAL_F_ELGAMAL_PUBLIC_ENCRYPT,0),  "ElGamal_public_encrypt"},
+  {ERR_PACK(0,ELGAMAL_F_ELGAMAL_PRIVATE_DECRYPT,0), "ElGamal_private_decrypt"},
+  { 0, NULL }
+};
+
+static ERR_STRING_DATA ElGamal_str_reasons[] = 
+{
+  { ELGAMAL_R_UNKNOWN_PADDING_TYPE, "unknown padding type" },
+  { ELGAMAL_R_DATA_GREATER_THAN_MOD_LEN, "data longer than modulus length" },
+  { ELGAMAL_R_PADDING_CHECK_FAILED, "padding check failed" },
+  { 0, NULL }
+};
+
+void
+ERR_load_ElGamal_strings( void )
+{
+  static int init = 1;
+
+  if (init)
+    {
+      init = 0;
+
+      ERR_load_strings(ERR_LIB_ELGAMAL, ElGamal_str_functs);
+      ERR_load_strings(ERR_LIB_ELGAMAL, ElGamal_str_reasons);
+    }
+}
+
+int
+ElGamal_public_check( DSA *dsa )
+{
+  BIGNUM res;
+  BN_MONT_CTX *mont;
+  BN_CTX *ctx;
+  int r = 0;
+
+  /* Check that g^q = 1 (mod p), and that y^q = 1 (mod p) */
+  /* to avoid attacks involving generators which produce small */
+  /* subgroups */
+
+  BN_init(&res);
+  if ((ctx = BN_CTX_new()) == NULL) goto err;
+  if ((mont = BN_MONT_CTX_new()) == NULL) goto err;
+  if (! BN_MONT_CTX_set(mont, dsa->p, ctx)) goto err;
+
+  if (! BN_mod_exp_mont(&res, dsa->g, dsa->q, dsa->p, ctx, mont)) goto err;
+  if (! BN_is_one(&res)) goto err;
+  if (! BN_mod_exp_mont(&res, dsa->pub_key, dsa->q, dsa->p, ctx, mont)) goto err;
+  if (! BN_is_one(&res)) goto err;
+  r = 1; /* Key is OK */
+
+ err:
+  BN_clear_free(&res);
+  if (ctx) BN_CTX_free(ctx);
+  if (mont) BN_MONT_CTX_free(mont);
+
+  return r;
+}
+
+int
+ElGamal_public_encrypt( int flen, unsigned char *from,
+			unsigned char *to,
+			DSA *dsa, int padding )
+			    
+{
+  unsigned char *buf, *p;
+  int num = 0, i, j, k, r = -1;
+  BIGNUM kappa, alpha, beta, f;
+  BIGNUM BETA, F;
+  BN_MONT_CTX *pmont;
+  BN_CTX *ctx = NULL;
+
+  num = BN_num_bytes(dsa->p) ;
+  BN_init(&alpha);
+  BN_init(&beta);
+  BN_init(&kappa);
+  BN_init(&f);
+  BN_init(&BETA);
+  BN_init(&F);
+
+  if ((ctx = BN_CTX_new()) == NULL) goto err;
+  if ((pmont = BN_MONT_CTX_new()) == NULL) goto err;
+  if (! BN_MONT_CTX_set(pmont, dsa->p, ctx)) goto err;
+  if ((buf = (unsigned char *)Malloc(num)) == NULL) {
+    ElGamalerr(ELGAMAL_F_ELGAMAL_PUBLIC_ENCRYPT, ERR_R_MALLOC_FAILURE);
+    goto err;
+  }
+
+  /* generate k s.t. 1 <= k <= q-1 */
+  do {
+    if (! BN_rand(&kappa, BN_num_bits(dsa->q), 1, 1)) goto err;
+  } while (BN_cmp(&kappa, dsa->q) < 0);
+
+  switch (padding) {
+  case ELGAMAL_PKCS1_PADDING:
+    i = RSA_padding_add_PKCS1_type_2(buf, num, from, flen);
+    break;
+  case ELGAMAL_PKCS1_OAEP_PADDING:
+    i = RSA_padding_add_PKCS1_OAEP(buf, num, from, flen, NULL, 0);
+    break;
+  case ELGAMAL_NO_PADDING:
+    i = RSA_padding_add_none(buf, num, from, flen);
+    break;
+  default:
+    ElGamalerr( ELGAMAL_F_ELGAMAL_PUBLIC_ENCRYPT, ELGAMAL_R_UNKNOWN_PADDING_TYPE );
+    goto err;
+  }
+
+  if (i <= 0) goto err;
+
+  if (BN_bin2bn(buf, num, &f) == NULL) goto err;
+
+  /* Set alpha = g^k (mod p) */
+  if (!BN_mod_exp_mont(&alpha, dsa->g, &kappa, dsa->p, ctx, pmont)) goto err;
+
+  /* Set beta = M * y^k (mod p) */
+  if (!BN_mod_exp_mont(&beta, dsa->pub_key, &kappa, dsa->p, ctx, pmont)) goto err;
+
+  BN_to_montgomery(&F, &f, pmont, ctx);
+  BN_to_montgomery(&BETA, &beta, pmont, ctx);
+  if (!BN_mod_mul_montgomery(&BETA, &BETA, &F, pmont, ctx)) goto err;
+  BN_from_montgomery(&beta, &BETA, pmont, ctx);
+
+  /* Squirt out alpha, left padded to modulus size with zero bytes */
+  j = BN_num_bytes(&alpha);
+  i = BN_bn2bin(&alpha, &(to[num-j]));
+  for(k=0; k<(num-i); k++) to[k]=0;
+
+  /* Follow this with beta */
+  p = &(to[num]);
+  j = BN_num_bytes(&beta);
+  i = BN_bn2bin(&beta, &(p[num-j]));
+  for(k=0; k<(num-i); k++) p[k]=0;
+
+  r = num*2;
+
+ err:
+  if (ctx != NULL) BN_CTX_free(ctx);
+  if (pmont != NULL) BN_MONT_CTX_free(pmont);
+  BN_clear_free(&alpha);
+  BN_clear_free(&beta);
+  BN_clear_free(&beta);
+  BN_clear_free(&kappa);
+  BN_clear_free(&f);
+  BN_clear_free(&BETA);
+  BN_clear_free(&F);
+  if (buf != NULL) {
+    memset(buf, 0, num);
+    Free(buf);
+  }
+  return r;
+}
+
+int ElGamal_private_decrypt( int flen, unsigned char *from,
+			     unsigned char *to,
+			     DSA *dsa, int padding )
+{
+
+  BIGNUM alpha, beta, gamma, delta, p1a;
+  BIGNUM BETA, GAMMA, DELTA;
+  BN_CTX *ctx;
+  BN_MONT_CTX *pmont;
+  unsigned char *p, *buf = NULL;
+  int j, r = -1, num;
+
+  BN_init(&alpha);
+  BN_init(&beta);
+  BN_init(&gamma);
+  BN_init(&delta);
+  BN_init(&p1a);
+  BN_init(&BETA);
+  BN_init(&GAMMA);
+  BN_init(&DELTA);
+  if ((ctx = BN_CTX_new()) == NULL) goto err;
+  if ((pmont = BN_MONT_CTX_new()) == NULL) goto err;
+  if (! BN_MONT_CTX_set(pmont, dsa->p, ctx)) goto err;
+
+  num = BN_num_bytes(dsa->p);
+
+  /* set p1a to be equal to p-1-x, where x is the private key */
+  if (BN_copy(&p1a, dsa->p) == NULL) goto err;
+  if (! BN_sub_word(&p1a, 1)) goto err;
+  if (! BN_sub(&p1a, &p1a, dsa->priv_key)) goto err;
+
+  if ((buf = (unsigned char *)Malloc(num)) == NULL) {
+    ElGamalerr(ELGAMAL_F_ELGAMAL_PRIVATE_DECRYPT, ERR_R_MALLOC_FAILURE);
+    goto err;
+  }
+
+  if (flen > num*2) {
+    ElGamalerr(ELGAMAL_F_ELGAMAL_PRIVATE_DECRYPT, ELGAMAL_R_DATA_GREATER_THAN_MOD_LEN);
+    goto err;
+  }
+
+  /* Copy the cipher text into the two numbers alpha and beta */
+  if (BN_bin2bn(from, flen / 2, &alpha) == NULL) goto err;
+  if (BN_bin2bn(&(from[flen/2]), flen / 2, &beta) == NULL) goto err;
+  
+  if (! BN_mod_exp_mont(&gamma, &alpha, &p1a, dsa->p, ctx, pmont)) goto err;
+  BN_to_montgomery(&GAMMA, &gamma, pmont, ctx);
+  BN_to_montgomery(&BETA, &beta, pmont, ctx);
+  if (! BN_mod_mul_montgomery(&DELTA, &GAMMA, &BETA, pmont, ctx)) goto err;
+  BN_from_montgomery(&delta, &DELTA, pmont, ctx);
+
+  /* Now delta should contain the (possibly padded) plaintext */
+  p = buf;
+  j = BN_bn2bin(&delta, p);
+
+  switch( padding ) {
+  case ELGAMAL_PKCS1_PADDING:
+    r = RSA_padding_check_PKCS1_type_2(to, num, buf, j, num);
+    break;
+  case ELGAMAL_PKCS1_OAEP_PADDING:
+    r = RSA_padding_check_PKCS1_OAEP(to, num, buf, j, num, NULL, 0);
+    break;
+  case ELGAMAL_NO_PADDING:
+    r = RSA_padding_check_none(to, num, buf, j, num);
+    break;
+  default:
+    ElGamalerr(ELGAMAL_F_ELGAMAL_PRIVATE_DECRYPT, ELGAMAL_R_UNKNOWN_PADDING_TYPE);
+    goto err;
+  }
+
+  if (r < 0)
+    ElGamalerr(ELGAMAL_F_ELGAMAL_PRIVATE_DECRYPT, ELGAMAL_R_PADDING_CHECK_FAILED);
+
+ err:
+  if (ctx != NULL) BN_CTX_free(ctx);
+  if (pmont != NULL) BN_MONT_CTX_free(pmont);
+  BN_clear_free(&alpha);
+  BN_clear_free(&beta);
+  BN_clear_free(&gamma);
+  BN_clear_free(&delta);
+  BN_clear_free(&p1a);
+  BN_clear_free(&BETA);
+  BN_clear_free(&GAMMA);
+  BN_clear_free(&DELTA);
+  if (buf != NULL) {
+    memset(buf, 0, num);
+    Free(buf);
+  }
+  return r;
+}
+bool
+valid_ciphertext_length( const u_int32_t len, struct connection *c )
+{
+  EVP_PKEY *pk = c->key;
+  bool ret = FALSE;
+
+  if ((!pk) || (len == 0)) return FALSE;
+  switch(pk->type) {
+  case EVP_PKEY_RSA:
+    if (len % BN_num_bytes(pk->pkey.rsa->n) == 0) ret = TRUE;
+    break;
+  case EVP_PKEY_DSA:
+    if (len % (2 * BN_num_bytes(pk->pkey.dsa->p)) == 0) ret = TRUE;
+    break;
+  default:
+    return FALSE;
+  }
+
+  return ret;
+}
+
+static void
+alloc_ciphertext( const u_int32_t len,
+		  EVP_PKEY *pk,
+		  u_char **c,
+		  u_int32_t *ms,
+		  u_int32_t *bsize,
+		  u_int32_t *bl )
+{
+  int modsize, chunksize, blocks;
+  const int padsize = 2 * SHA1_DIGEST_SIZE - 1;
+  u_int32_t clen;
+
+  switch(pk->type)
+    {
+    case EVP_PKEY_RSA:
+      {
+	RSA *rsa = pk->pkey.rsa;
+	modsize = BN_num_bytes(rsa->n);
+      }
+      break;
+    case EVP_PKEY_DSA:
+      {
+	DSA *dsa = pk->pkey.dsa;
+	modsize = BN_num_bytes(dsa->p) * 2;
+      }
+      break;
+    }
+  chunksize = modsize - padsize;
+  blocks = (len + chunksize - 1) / chunksize;
+  clen = blocks * modsize;
+  *c = malloc(clen);
+  *bsize = chunksize;
+  *bl = blocks;
+  *ms = modsize;
+}
+
+void
+pubkey_encrypt_chunk( chunk_t *ch, struct state *st )
+{
+  struct connection *c = st->st_connection;
+  u_char *str = ch->ptr;
+  u_int32_t len = ch->len;
+  EVP_PKEY *pk = NULL;
+  u_char *ciph;
+  u_int32_t ms, bs, bl, clen;
+  u_int16_t auth = st->st_oakley.auth;
+  int i;
+
+  switch(auth) {
+  case OAKLEY_RSA_ENC:
+  case OAKLEY_RSA_ENC_REV:
+    for(i=0; i<MAX_OTHER; i++) {
+      if ((c->other[i].type == EVP_PKEY_RSA) &&
+	  (c->other[i].cert != NULL)) {
+	pk = X509_get_pubkey((X509 *)c->other[i].cert);
+	break;
+      }
+    }
+    break;
+  case OAKLEY_ELGAMAL_ENC:
+  case OAKLEY_ELGAMAL_ENC_REV:
+    for(i=0; i<MAX_OTHER; i++) {
+      if ((c->other[i].type == EVP_PKEY_DSA) &&
+	  (c->other[i].cert != NULL)) {
+	pk = X509_get_pubkey((X509 *)c->other[i].cert);
+	break;
+      }
+    }
+    break;
+  default:
+    DBG(DBG_PARSING,
+    DBG_log("Non PK authentication scheme in state");
+    );
+    return;
+  }
+
+  if (!pk) {
+    DBG(DBG_PARSING,
+    log("Unable to select an encryption key");
+    );
+    return;
+  }
+
+  switch(pk->type) {
+  case EVP_PKEY_RSA:
+    {
+      alloc_ciphertext(len, pk, &ciph, &ms, &bs, &bl);
+    }
+    break;
+  case EVP_PKEY_DSA:
+    {
+      alloc_ciphertext(len, pk, &ciph, &ms, &bs, &bl);
+    }
+    break;
+  default:
+    log("Unknown key type: %d", pk->type);
+    break;
+  }
+
+  for(i=0; i<bl; i++) {
+    u_char *pst = &str[i * bs];
+    u_char *cst = &ciph[i * ms];
+    u_int32_t plen = (i < bl-1) ? bs : len % bs;
+
+    switch(pk->type) {
+    case EVP_PKEY_RSA:
+      {
+	RSA *rsa = pk->pkey.rsa;
+	
+	clen = RSA_public_encrypt(plen, pst, cst, rsa, RSA_PKCS1_OAEP_PADDING);
+      }
+      break;
+    case EVP_PKEY_DSA:
+      {
+	DSA *dsa = pk->pkey.dsa;
+
+	clen = ElGamal_public_encrypt(plen, pst, cst, dsa, ELGAMAL_PKCS1_OAEP_PADDING);
+      }
+      break;
+    default:
+      log("Unknown cert type: %d", pk->type);
+      break;
+    }
+  }
+
+  memset(ch->ptr, 0, ch->len);
+  freeanychunk(*ch);
+  ch->len=bl*ms;
+  ch->ptr=ciph;
+}
+
+void
+privkey_decrypt_chunk( chunk_t *ch, struct state *st )
+{
+  u_int32_t i, bl, bs, clen;
+  struct connection *c = st->st_connection;
+  EVP_PKEY *pk = c->key;
+  u_char *str = ch->ptr;
+  u_char *pst;
+  u_int32_t ptr, plen;
+
+  switch(pk->type) {
+  case EVP_PKEY_RSA:
+    {
+      RSA *rsa = pk->pkey.rsa;
+      bs = BN_num_bytes(rsa->n);
+    }
+    break;
+  case EVP_PKEY_DSA:
+    {
+      DSA *dsa = pk->pkey.dsa;
+      bs = 2 * BN_num_bytes(dsa->p);
+    }
+    break;
+  default:
+    log("Unknown key type: %d", pk->type);
+    break;
+  }
+  clen = ch->len;
+  bl = clen / bs;
+  pst = malloc(clen);
+  ptr = 0;
+  for(i=0; i<bl; i++) {
+    switch(pk->type) {
+    case EVP_PKEY_RSA:
+      {
+	RSA *rsa = pk->pkey.rsa;
+	if (clen >= bs) {
+	  plen = RSA_private_decrypt( bs, &str[i * bs], &pst[ptr], rsa, RSA_PKCS1_OAEP_PADDING );
+	  if (plen == 0) {
+	    log_err();
+	  }
+	} else /* Ciphertext is too short */
+	  plen = 0;
+      }
+      break;
+    case EVP_PKEY_DSA:
+      {
+	DSA *dsa = pk->pkey.dsa;
+	
+	if (clen >= bs) {
+	  plen = ElGamal_private_decrypt( bs, &str[i * bs], &pst[ptr], dsa, ELGAMAL_PKCS1_OAEP_PADDING );
+	  if (plen == 0) {
+	    log_err();
+	  }
+	} else /* Short ciphertext - don't try and decrypt */
+	  plen = 0;
+      }
+      break;
+    default:
+      log("Unknown key type: %d", pk->type);
+      plen = 0;
+      break;
+    }
+    ptr += plen;
+  }
+  freeanychunk(*ch);
+  ch->ptr = pst;
+  ch->len = ptr;
+}
+
+bool
+use_openssl( struct connection *c )
+{
+// Using data from connection *c, we can determine if we are currently using 
+// the openssl-related functions or not.
+// ie: 
+//   c->cert
+//   c->key
+//   c->cert_options
+//
+// also use c->policy to determine policy.
+//
+// Return 0 if openssl, otherwise 1.
+
+	if (c->policy & POLICY_OPENSSL) {
+		if ((c->cert != NULL) || 
+			(c->key != NULL) || 
+			(c->cert_options != 0)) 
+		{
+			// OPENSSL
+			return 1;
+		}
+		else
+		{
+			// RSASIG only
+			return 0;
+		}
+	}
+    else 
+	{
+		// PSK
+		return 0;
+	}
+}
+
+#endif /* OPENSSL */
